#include <iostream>
#include <set>
#include <vector>
#include <list>

using namespace std;

struct place
{
    long long time;
    int where;
    place(long long t = 0,int w = 0) { time = t; where = w; }
    bool operator<(const place &a) const
    {
        if (time <= a.time) return true;
        else if (time > a.time) return false;
        return where < a.where;
    }
};

struct edge {
    long long v,t,a,l;
    long long w;
};


#define MAXINT (2000000000*(long long)2000000000)

long long n,m,i,j,a,w,t,l,N;

typedef list<edge> elist;
typedef vector<elist> tgraf;
place   vert[51000];

tgraf graf;

int main()
{
    cin >> N;
    while (N-- > 0) {
        cin >> n >> m;
        graf.resize(n+1);
        for (i = 0;i <= n;i++) {
            graf[i].clear();
            vert[i].time = MAXINT;
            vert[i].where = i;
        }
        for (i = 0;i < m;i++) {
            edge e;
            int u;
            cin >> u >> e.v >> e.w >> e.t >> e.a >> e.l;
            graf[u].push_back(e);
        }

        set<place> kolejka;
        vert[1].time = 0;
        kolejka.insert(vert[1]);

        while (!kolejka.empty()) {
            place p = *kolejka.begin();
 //           cout << "ze zbioru " << p.where << " -> " << p.time << endl;
            kolejka.erase(p);
            long long tt0 = vert[p.where].time;

            for (elist::iterator it = graf[p.where].begin();it != graf[p.where].end();it++) {
                long long t0 = tt0;
                //cout << "t0 w " << p.where << " = " << t0 << endl; 
                // relaksacja
                if (it->a == 0 && it->t == 0 && it->l == 0) {
                }
                else {
                    //cout << "v = " << it-> v << " t0 = " << t0 << ", a = " << it->a << ", t = " << it->t << ", l = " << it->l << endl;
                    if (t0  < it->a) t0 = it->a;
                    else if ((t0 - it->a) % it->t < it->l) { // ok
                            
                    }
                    else t0 += it->t - ((t0-it->a) % it->t);
                }
//                cout << "przed dodaniem krawedzi do " << it->v << " t0 = " << t0 << endl;
                t0 += it->w;
                
                if (t0 < vert[it->v].time) {
                    // usunac wierzcholek z kolejki
                    set<place>::iterator iii = kolejka.find(vert[it->v]);
                    if (iii != kolejka.end()) { 
                        kolejka.erase(iii); 
                    }
                    vert[it->v].time = t0;
                    kolejka.insert(vert[it->v]);
                }
            }
        }
        if (vert[n].time == MAXINT) {
            cout << "NIE" << endl;
        }
        else cout << vert[n].time << endl;
    }
    return 0;
}
